<?php
/*---------------------------------------------------------------*/
/*
    Titre : Convertisseur de température                                                                                 
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=992
    Date dition     : 15 Fv 2019                                                                                        
    Date mise  jour : 26 Aout 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
*/
/*---------------------------------------------------------------*/

      function conv_temp($val , $type_val , $type_wanted){
     $tab_val = array("C", "F", "K", "Re", "Ra"); 
      if (!(in_array($type_val, $tab_val) && in_array($type_wanted, $tab_val))) 
      return 0; 
      switch ($type_val) { 
      case "C" : // degrés Celsius 
      switch ($type_wanted) { 
      case "C" : 
       return $val; 
      case "F" : 
       return ($val * 9 / 5 + 32); 
      case "K" : 
       return ($val + 273.16); 
      case "Re" : 
       return ($val * 4 / 5); 
      case "Ra" : 
       return (($val + 273.16) * 1.8); } 
      case "F" : // degrés Fahrenheit 
      switch ($type_wanted) { 
      case "C" : 
       return (($val - 32) * 5 / 9); 
      case "F" : 
       return $val; 
      case "K" : 
       return ((($val - 32) * 5 / 9) + 273.16); 
      case "Re" : 
       return (($val - 32) * 4 / 9); 
      case "Ra" : 
       return ($val - 32 + 273.16 * 9 / 5); } 
      case "K" : // degrés Kelvin 
      switch ($type_wanted) { 
      case "C" : 
       return ($val - 273.16); 
      case "F" : 
       return (($val - 273.16) * 9 / 5 + 32); 
      case "K" : 
       return $val; 
      case "Re" : 
       return (($val - 273.16) * 4 / 5); 
      case "Ra" : 
       return ($val * 1.8); } 
      case "Re" : // degrés Reaumur 
      switch ($type_wanted) { 
      case "C" : 
       return ($val * 5 / 4); 
      case "F" : 
       return ($val * 9 / 4 + 32); 
      case "K" : 
       return ($val * 5 / 4 + 273.16); 
      case "Re" : 
       return $val; 
      case "Ra" : 
       return (($val * 5 / 4 + 273.16) * 1.8); } 
      case "Ra" : // degrés Rankine 
      switch ($type_wanted) { 
      case "C" : 
       return ($val / 1.8 - 273.16); 
      case "F" : 
       return ($val - 273.16 * 9 / 5 + 32); 
      case "K" : 
       return ($val / 1.8); 
      case "Re" : 
       return (($val / 1.8 - 273.16) * 4 / 5); 
      case "Ra" : 
       return $val; 
      }
     }
    }
?>